/*
  Copyright (C) 2004 sanmaiwashi
*/

#include <stdlib.h>
#include <string.h>
#include "common.h"
#include "commutil.h"

#define min(a, b)\
	((a) < (b) ? (a) : (b))

static inline u8 is_sjis(u8 *s)
{
	if(*(s + 1) && ((*s >= 0x81 && *s <= 0x9f) ||
					(*s >= 0xe0 && *s <= 0xfc)) &&
	   ((*(s + 1) >= 0x40 && *(s + 1) <= 0x7e) ||
		(*(s + 1) >= 0x80 && *(s + 1) <= 0xfc)))
		return TRUE;
	return FALSE;
}

void mbcs_splitpath(const char *path,
					char *drive,
					char *dir,
					char *fname,
					char *ext)
{
	if(strlen(path) >= (_MAX_DRIVE - 2) && *(path + _MAX_DRIVE - 2) == ':') {
		if (drive) {
			strncpy(drive, path, _MAX_DRIVE - 1);
			*(drive + _MAX_DRIVE - 1) = '\0';
		}
		path += _MAX_DRIVE - 1;
	}
	else if (drive) {
		*drive = '\0';
	}

	char *last_slash = NULL, *dot = NULL;
	char *p = (char *)path;
	for (; *p; p++) {
		if (is_sjis((u8 *)p))
			p++;
		else {
            if (*p == '/' || *p == '\\')
                last_slash = p + 1;
            else if (*p == '.')
                dot = p;
		}
	}

	unsigned len;
	if (last_slash) {
		if (dir) {
			len = min(((char *)last_slash - (char *)path) / sizeof(char),
						(_MAX_DIR - 1));
			strncpy(dir, path, len);
			*(dir + len) = '\0';
		}
		path = last_slash;
	}
	else if (dir) {
		*dir = '\0';
	}

	if (dot && (dot >= path)) {
		if (fname) {
			len = min(((char *)dot - (char *)path) / sizeof(char),
						(_MAX_FNAME - 1));
			strncpy(fname, path, len);
			*(fname + len) = '\0';
		}
		if (ext) {
			len = min(((char *)p - (char *)dot) / sizeof(char),
						(_MAX_EXT - 1));
			strncpy(ext, dot, len);
			*(ext + len) = '\0';
		}
	}
	else {
		if (fname) {
			len = min(((char *)p - (char *)path) / sizeof(char),
						(_MAX_FNAME - 1));
			strncpy(fname, path, len);
			*(fname + len) = '\0';
		}
		if (ext) {
			*ext = '\0';
		}
	}
}

