/*
  Copyright (C) 2004 sanmaiwashi
*/

#include <stdlib.h>
#include <string.h>
#include "common.h"
#include "commutil.h"

static inline u8 is_sjis(u8 *s)
{
	if(*(s + 1) && ((*s >= 0x81 && *s <= 0x9f) ||
					(*s >= 0xe0 && *s <= 0xfc)) &&
	   ((*(s + 1) >= 0x40 && *(s + 1) <= 0x7e) ||
		(*(s + 1) >= 0x80 && *(s + 1) <= 0xfc)))
		return TRUE;
	return FALSE;
}

static inline unsigned char *mbcs_mbsdec(const unsigned char *start,
										 const unsigned char *current)
{
	if(current <= start)
		return NULL;

	for (; *start; start++) {
		if((current - 1) == start)
			break;
		if (is_sjis((u8 *)start)) {
			if((start + 2) == current)
				break;
			start++;
		}
	}
	return (unsigned char *)start;
}

void exp_mbcs_makepath(char *path,
					   const char *drive,
					   const char *dir,
					   const char *fname,
					   const char *ext)
{
	if (drive && *drive) {
		*path++ = *drive;
		*path++ = ':';
	}

	const char *p;
	if ((p = dir) && *p) {
		do {
			*path++ = *p++;
		}
		while (*p);
		if (*(p= (const char *)mbcs_mbsdec((const unsigned char *)dir,
										   (const unsigned char *)p)) != '/' && *p != '\\') {
			*path++ = '\\';
		}
	}

	if (p = fname) {
		while (*p) {
			*path++ = *p++;
		}
	}

	if (p = ext) {
		if (*p && *p != '.') {
			*path++ = '.';
		}
		while (*path++ = *p++);
	}
	else {
		*path = '\0';
	}
}
