#if !defined(GLOBL_H_INCLUDED)
#define GLOBL_H_INCLUDED

#include "../snes9x/snes9x.h"

struct OOptions {
	unsigned char JPenvFlag;
	unsigned long JoyReadRateMask;

	//screenshot
	unsigned char SaveImagefileFormat;
	unsigned char ReduceTheColorTo256;
	unsigned char ReduceTheColorTo256IfWithin;
	unsigned char ImagefileHiresStretch;
	unsigned char RLEcompression256bitmap;

	//SNES emulation settings
	unsigned char FixFrequency;
	short VolumeLevel;
	unsigned char GFXengine2;
	unsigned char APURAMInitialValue0;
	unsigned char APURAMInitialValue;
	unsigned char SRAMInitialValue0;
	unsigned char SRAMInitialValue;
	unsigned char RAMInitialValue; // Original

	//SNES debug settings
	unsigned char DisplayScreenBufferAll;

	//condition
	u8 AVI_Recording;
};

struct XXxxcode {
	unsigned char CheatNum;
	unsigned char CheatNumRock;
	unsigned char CheatNumRock_Old;
	unsigned char CheatFlag;
	unsigned char CheatNumBackFlag;
};

struct XXxxcdda {
	unsigned char Enable;
	unsigned char Drv;

	unsigned char Soundlink_cd_track;
	unsigned char Max_Soundlink_cd_track;

	unsigned char Sound_ShowTimer;

	unsigned char Sound_SyncFlag1;
	unsigned char Sound_SyncFlag2;
	unsigned char Sound_SyncFlag3;

	unsigned char Sound_SyncFirstSec;
	unsigned char Sound_SyncNowSec;
	unsigned char Sound_SyncDiffSec;

	unsigned char Sound_NowTime;
	unsigned char Sound_OldTime;

	unsigned char Sound_NowSec;
	unsigned char Sound_OldSec;

	unsigned char Sound_SyncSpeed;

	unsigned char VoicerCDChange;
};

struct XXxxbsx {
	unsigned char BsxRomCheck;
	unsigned char Bszelda_Chr;
	unsigned char Bssound_Time;
};

struct XXxxsystem {
	unsigned char Speedflag;
	unsigned char SpeedEnable;
	unsigned char SpeedPercent;
	unsigned char PassWord;
	unsigned char NormalSnap;
};

struct XXxxMovie {
    uint8 *REPLAY_RAM;
    uint32 REPLAY_RAM_COUNT;
    uint32 REPLAY_RAM_COUNT_MAX;
    bool8 Replay_play;
    bool8 Replay_rec;
    uint32 Replay_count;
    uint8 replay_data [14];
    uint8 replay_data_temp [14];
    uint8 replay_data_dummy;
    uint32 replay_data_count;
    bool8 Def_NormalSnap;
};

extern struct OOptions Options;
extern struct SSNESGameFixes SNESGameFixes;
extern struct XXxxcode Xxxcode;
extern struct XXxxcdda Xxxcdda;
extern struct XXxxbsx Xxxbsx;
extern struct XXxxsystem Xxxsystem;
extern struct XXxxMovie XxxMovie;
extern void S9xSwitchGFXengine(unsigned char engine2flag);

/*****************
 default settings
*****************/
#define OPTIONS_GFXENGINE2_DEF 1  // Original
#define OPTIONS_FIXFREQENCY_DEF 1
#define OPTIONS_JOYREADRATEMASK_DEF 0 // Original
#define OPTIONS_SAVEIMAGEFILEFORMAT_DEF 0
#define OPTIONS_REDUCETHECOLORTO256_DEF 0
#define OPTIONS_REDUCETHECOLORTO256IFWITHIN_DEF 1
#define OPTIONS_IMAGEFILEHIRESSTRETCH_DEF 1
#define OPTIONS_DISPLAYSCREENBUFFERALL_DEF 0
#define OPTIONS_RLECOMPRESSION256BITMAP_DEF 0
#define OPTIONS_SDD1PACK 0
#define OPTIONS_DISABLE_IRQ_CYCLECOUNT 1

#define OPTIONS_XXX_CDDAENABLE 0
#define OPTIONS_XXX_CDDADRV 0
#define OPTIONS_XXX_NORMALSNAP 0


#endif /* GLOBL_H_INCLUDED */
