#ifndef _UOSNESW_H_
#define _UOSNESW_H_

#include <stdlib.h>
#define STRICT
#include <windows.h>
#include <commctrl.h>
#include <mmsystem.h>
#include "resource.h"

struct sGUI {
	HWND hWnd;
	HWND hStatusWnd;
	HMENU hMenu;
	HMENU hVolMenu;
	HMENU hSysMenu;
	HMENU hRecentGamesMenu;
	HINSTANCE hInstance;
	HCURSOR Blank;
	HCURSOR GunSight;
	HCURSOR Arrow;
	DWORD dwStyleWindowed;
	DWORD dwStyleFullScreen;
	DWORD dwExStyle;

	bool AppMenuConnect;

	long DefaultWindowSizeW;
	long DefaultWindowSizeH;
	long DefaultWindowSizeWW;
	long DefaultWindowSizeHH;
	long WindowSizeW;
	long WindowSizeH;
	RECT WindowRectSetting;

	//Status bar size
	unsigned char NeedWindowSizeAddition;
	//Client Rect, .left == 0 .top == 0
	RECT ClientRect;
	//Screen xy Client Rect
	RECT sClientRect;

	volatile HANDLE FrameTimerSemaphore;

	BYTE Language;

	char SoundMode;
	bool Stereo;

	volatile bool ForcedPauseEmulation;
	volatile bool PauseEmulation;
	volatile bool StopEmulation;
	bool PauseLock;

	int Scale;
	unsigned char SupportHiRes;
	unsigned char DoubleRendering;
    unsigned char dRendering;
	int Stretch;
	bool FullScreen;
	bool DoubleBuffered;
	int DoubleRenderingModes8;
	int DoubleRenderingModes16;
	int FullscreenDisplayModeIndexNormal16;
	int FullscreenDisplayModeIndexDouble16;
	int FullscreenDisplayModeIndexNormal8;
	int FullscreenDisplayModeIndexDouble8;
	int CurFullscreenDisplayModeIndex;
	unsigned char ForceWindowedDirectDrawClipper;

	bool NeedDepthConvert;
	DWORD ScreenDepth;

	int RedShift;
	int GreenShift;
	int BlueShift;

    RECT SizeHistory [10];
    unsigned int FlipCounter;

	char FreezeFileDir[_MAX_PATH];
	POINT MousePosition;
	int MouseX;
	int MouseY;
	bool IgnoreNextMouseMove;
	unsigned long MouseButtons;

	DWORD PriorityClass;
	int ThreadPriority;

	BOOL DIuse;
	BOOL DSuse;

	BOOL DirectSoundNotify;

	unsigned char FileBrowseWindow;
	unsigned char WindowTopMost;

	unsigned char SwitchToWindowed;
	unsigned char Exit;
};

struct sLanguages {
	int idMenu;
	char *errInitDD;
	char *errModeDD;
	char *errInitSound;
	char *ApplyNeedRestart;
	char *errFrameTimer;
	char *S9xExitMessage;
	char *errMemoryInit;
	char *errSwitchGFX;
	char *errInitDI;
};

struct SSoundRates
{
	long rate;
	unsigned char stereo;
	unsigned char sixteen_bit;
//	int ident;
};

/*****************************************************************************/
/* uosnesw defines                                                           */
/*****************************************************************************/
#define ID_MAINSTATUSWINDOW 101

/*****************************************************************************/
/* Snes9x proc extern                                                        */
/*****************************************************************************/
extern "C" const char *S9xGetNumFilename (const char *dirstr,
										  const char *fext,
										  int *numsaved);
extern void MakeTurboStatus();

/*****************************************************************************/
/* uosnesw variables extern                                                  */
/*****************************************************************************/
extern "C" struct sGUI GUI;
extern "C" struct sGUI DefaultGUI;
extern struct sLanguages Languages[];
extern int superscope_turbo;
extern int superscope_pause;
extern unsigned char errConfigSwitch;
extern struct SSoundRates SoundRates[];
extern struct DDisplayMode DisplayMode[];

/*****************************************************************************/
/* uosnesw proc extern                                                       */
/*****************************************************************************/
extern BOOL OpenFile(HWND hWnd, char *FileName, char *FileTitle, char *InitialROMFileDirectory);
extern BOOL OpenFileEx(HWND hWnd, char *FileName, char *FileTitle, char *InitialROMFileDirectory);
extern void ConfigDlgProp(HWND hWnd);
extern unsigned char DisplaySNESCheatCodeWindow();
extern const char *S9xGetSPCFilename ();
extern char *S9xwGetSavedSPCNumberAndExtStr();
extern char *S9xwGetScreenImageFilename(char *ImageTypeExt);
extern char *S9xwGetSavedScreenImageNumberAndTypeStr();
extern bool InitUosnesw(void);
extern void DeinitUosnesw(void);
extern void S9xDrawScreenImage();
extern void ScreenRedraw(HWND hWnd);
extern void S9xSetWinPixelFormat ();
extern void S9xSetWindowPos();
extern void RefreshRectParams();
extern void ScreenInit();
extern void ProcessSound();
extern void DisplayStatusInfo();
extern unsigned char SwitchScreenMode(unsigned char Windowed);
extern void SetMenuStatus(HMENU hAppMenu, HMENU hSysMenu);
extern void SetRecentFileMenu();
extern void CurFullscreenDisplayModeIndexChange();
extern BOOL UosneswSetupFrameTimer(DWORD ms);

extern void DoAVIOpen(const char* filename);
extern void DoAVIClose(int reason);

#endif /* _UOSNESW_H_ */

